#include<reg51.h>

#define LCD P0
sbit RS=P0^0;
sbit RW=P0^1;
sbit EN=P0^2;


void InitLCD(void);
void WriteCmdLCD(unsigned char);
void WriteCharLCD(unsigned char);
void DisplayStrLCD(unsigned char *);
void DisplayIntegerLCD(int);
void GoToLCD(unsigned char,unsigned char);
void ClearScreenLCD(void);
void DelayMS(int);

void InitLCD(void)
{
	WriteCmdLCD(0x28);
	WriteCmdLCD(0x0e);
	WriteCmdLCD(0x01);
	WriteCmdLCD(0x06);
	WriteCmdLCD(0x80);
}

void WriteCmdLCD(unsigned char c)
{
	LCD=((c & 0xf0) | 0x04);
	EN=0;

    LCD=(((c & 0x0f)<<4)|0x04);

	EN=0;
	DelayMS(2);
}

void WriteCharLCD(unsigned char c)
{
	LCD=((c&0xf0)|0x05);
    EN=0;
   
	LCD=(((c & 0x0f)<<4)|0x05);

    EN=0;
	DelayMS(2);

}

void DisplayStrLCD(unsigned char *s)
{
	while(*s)
	WriteCharLCD(*s++);

}

void DisplayIntegerLCD(int n)
{
unsigned char c[6];
unsigned int i=0;
  if(n<0)
  {
    WriteCharLCD('-');
    n=-n;
  }
  if(n==0)
    WriteCharLCD('0');
  while(n>0)
  {
    c[i++]=(n%10)+48;
    n/=10;
  }
  while(i-->=1)
    WriteCharLCD(c[i]);
}

void GoToLCD(unsigned char row,unsigned char pos)
{
	if(row==1)
	{
		WriteCmdLCD(0x80+pos-1);
	}
	if(row==2)
	{
	 	WriteCmdLCD(0xc0+pos-1);	
	}
}
void ClearScreenLCD(void)
{
	WriteCmdLCD(0x01);
	WriteCmdLCD(0x80);		
}
void DelayMS(int i)
{
  unsigned int j;
  while(i-->0)
  	for(j=0;j<250;j++);
}
